// TextGrab.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "TextGrab.h"
#include <windowsx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define TG_STRING_LEN 7

#include "..\TextGrabber\resource.h"
CString g_sDebug;

void DebugPrint()
{
	CWnd *pNotepad = CWnd::FindWindow(NULL,_T("Untitled - Notepad"));
	if (!pNotepad)
	{
		AfxMessageBox(_T("You must run Notepad with \"Untitled - Notepad\" caption to debug!"));
		return;
	}
	CEdit *pEdit = (CEdit *) (pNotepad->GetDlgItem(0x000f));
	pEdit->ReplaceSel(g_sDebug);
}

#define TG_TITLE	_T("TextGrabber - When you really need that text!")
//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

/////////////////////////////////////////////////////////////////////////////
// CTextGrabApp

BEGIN_MESSAGE_MAP(CTextGrabApp, CWinApp)
	//{{AFX_MSG_MAP(CTextGrabApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextGrabApp construction

CTextGrabApp::CTextGrabApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CTextGrabApp object

CTextGrabApp theApp;
CEdit *g_peditMain = NULL;
HHOOK g_hHook = NULL;
CButton *g_pbtnClear = NULL;
CButton *g_pbtnCSV = NULL;
CButton *g_pbtnNarrow = NULL;
CEdit *g_peditClass = NULL;

CString CSV(CString sText, BOOL bCSV, BOOL bAddComma)
{
	CString sResult;

	if (bCSV)
	{
		sText.Replace(_T("\""),_T("\"\""));
		if ((sText.Find(_T(',')) != -1) || (sText.Find(_T('"')) != -1))
		{
			// Comma or quote in string
			sResult = _T("\"") + sText + _T("\"") + (bAddComma ? _T(",") : _T(""));
		} else
		{
			// No comma in string
			sResult = sText + (bAddComma ? _T(",") : _T(""));
		}
	} else
	{
		sResult = sText + (bAddComma ? _T("\t") : _T(""));
	}
	return sResult;
}

void LS_InvertWindowBorder(CWnd *pWnd)
{
    HDC dc;
    RECT r,top,bottom,left,right;

    dc = pWnd->GetDC()->m_hDC;
    if (dc == NULL) return;
    pWnd->GetClientRect(&r);
    top = bottom = left = right = r;
    top.bottom = top.top + 2;
    bottom.top = bottom.bottom - 2;
    left.right = left.left + 2;
    right.left = right.right - 2;

    left.top = top.bottom;
    left.bottom = bottom.top;
    right.top = top.bottom;
    right.bottom = bottom.top;

    InvertRect(dc,&top);
    InvertRect(dc,&bottom);
    InvertRect(dc,&left);
    InvertRect(dc,&right);
}

BOOL inline ischar(TCHAR c)
{
    return (c == _T('\n')) || (c == _T('\r')) || (c == _T('\t')) || ( (c >= 32) && (c <= 127) );
}

CString MemoryStrings(LPCSTR szMemory, DWORD dwSize)
{
/*
    HANDLE hFile;
    hFile = CreateFile("E:\\temp.dat", GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, 0, NULL);
    DWORD dwWritten;
    WriteFile(hFile, szMemory, dwSize, &dwWritten, NULL);
    CloseHandle(hFile);
*/
    CString sResult = _T("");
    LPCSTR szFirstChar = NULL;
    DWORD iFirstChar = 0;
    DWORD iIndex = 0;
    DWORD iSeqChars = 0;
    TCHAR *szTemp;
    CString sTemp;
    BOOL bUnicode = FALSE;

    if (dwSize < TG_STRING_LEN)
        return sResult;

    // add any strings 5 chars or greater that are not all the same character
    while (iIndex < (dwSize - TG_STRING_LEN))
    {
        if (ischar(szMemory[iIndex]))
        {
            if (!szFirstChar)
            {
                szFirstChar = &szMemory[iIndex];
                iFirstChar = iIndex;
                if ((szFirstChar[1] == 0x00) && (ischar(szFirstChar[2])) && (szFirstChar[3] == 0x00) && (ischar(szFirstChar[4])))
                {
                    bUnicode = TRUE;
                }
            }
        } else
        {
            szFirstChar = NULL;
            iFirstChar = 0;
        }

        if (szFirstChar)
            iSeqChars++;
        else
            iSeqChars = 0;

        if (iSeqChars > TG_STRING_LEN - 1)
        {
            if ((szFirstChar[0] == szFirstChar[1]) && (szFirstChar[1] == szFirstChar[2]) && (szFirstChar[2] == szFirstChar[3]))
            {
                iSeqChars -= 1;
                szFirstChar += 1;
                iFirstChar += 1;
            } else
            {
                while (iIndex < dwSize)
                {
                    if (ischar(szMemory[iIndex]))
                    {
                        iIndex++;
                        if (bUnicode)
                            iIndex++;
                    } else
                        break;
                }

                size_t tempLength = sResult.GetLength() + (iIndex - iFirstChar) + 1;
                szTemp = sTemp.GetBuffer(tempLength);
                if (!bUnicode)
                {
                    size_t converted;
                    mbstowcs_s(&converted, szTemp, tempLength, szFirstChar, iIndex - iFirstChar);
                    szTemp[iIndex - iFirstChar] = 0x00;
                } else
                {
                    // Unicode
                    //wcstombs(szTemp, (wchar_t *) szFirstChar, (iIndex - iFirstChar) / 2);
                    _tcsncpy_s(szTemp, tempLength, (wchar_t *) szFirstChar, iIndex - iFirstChar);
                    szTemp[(iIndex - iFirstChar) / 2] = 0x00;
                    //szTemp[(iIndex - iFirstChar) / 2 + 1] = 0x00;
                }
                sTemp.ReleaseBuffer();

                sResult += sTemp;
                sResult += _T("\r\n");
                iSeqChars = 0;
                bUnicode = FALSE;
            }
        }
        iIndex++;
        if (bUnicode)
            iIndex++;
    }

    return sResult;
}

void InsertText(CEdit *pEdit, CString sText, BOOL bNarrow)
{
    pEdit->SetLimitText(0);
	pEdit->ReplaceSel(sText);
}

void LS_GetWindowInfo(CWnd *pWnd, CPoint pt)
{
	CString sTemp, sClassName;
	CEdit *pEdit;
	CWnd *pwndTemp;
	BOOL bCSV = FALSE;
    BOOL bNarrow = FALSE;

	if (!pWnd)
		return;

	if (!g_peditMain)
	{
		g_peditMain = ((CEdit *) (CWnd::FindWindow(NULL,TG_TITLE)->GetDlgItem(IDC_EDIT_TEXT)));
		if (!g_peditMain)
		{
			return;
		}
	}
	
	pEdit = g_peditMain;
	
	if (!g_peditClass)
	{
		g_peditClass = ((CEdit *) (CWnd::FindWindow(NULL,TG_TITLE)->GetDlgItem(IDC_EDIT_CLASS)));
		if (!g_peditClass)
		{
			return;
		}
	}
	
	if (!g_pbtnClear)
	{
		g_pbtnClear = ((CButton *) (CWnd::FindWindow(NULL,TG_TITLE)->GetDlgItem(IDC_CHECK_CLEAR)));
		if (!g_pbtnClear)
		{
			return;
		}
	}
	
	if (!g_pbtnCSV)
	{
		g_pbtnCSV = ((CButton *) (CWnd::FindWindow(NULL,TG_TITLE)->GetDlgItem(IDC_CHECK_CSV)));
		if (!g_pbtnCSV)
		{
			return;
		}
	}
	
	if (!g_pbtnNarrow)
	{
        g_pbtnNarrow = ((CButton *) (CWnd::FindWindow(NULL,TG_TITLE)->GetDlgItem(IDC_CHECK_MULTIBYTE)));
		if (!g_pbtnNarrow)
		{
			return;
		}
	}
	
	if (g_pbtnClear->GetCheck())
	{
		pEdit->SetRedraw(FALSE);
		pEdit->SetSel(0,-1);
		pEdit->Clear();
		pEdit->SetRedraw(TRUE);
		pEdit->Invalidate();
	}

	if (g_pbtnCSV->GetCheck())
	{
		bCSV = TRUE;
	}

	if (g_pbtnNarrow->GetCheck())
	{
		bNarrow = TRUE;
	}

//g_sDebug.Format("point: %d,%d\r\n",pt.x,pt.y);
//((CEdit *) (CWnd::FindWindow(NULL,"Untitled - Notepad")->GetDlgItem(0x000f)))->ReplaceSel(g_sDebug);

	CWnd *pwndMain = pWnd;
	pWnd->ScreenToClient(&pt);
	pwndTemp = pWnd->ChildWindowFromPoint(pt,CWP_ALL);
	if (IsWindow(pwndTemp->GetSafeHwnd()))
	{
		pWnd = pwndTemp;
	}

	// See if there is a smaller window encompassed by this window
	// and select that if there is

	CWnd *pwndUse = pWnd;

	pWnd->ModifyStyle(NULL,WS_DISABLED);
	pwndTemp = pwndMain->ChildWindowFromPoint(pt,CWP_SKIPDISABLED);
	if (pwndTemp)
	{
		// See if this window is inside the other one
		CRect rcInside, rcOutside;
		pwndTemp->GetWindowRect(&rcInside);
		pWnd->GetWindowRect(&rcOutside);
		if (rcOutside.PtInRect(CPoint(rcInside.left,rcInside.top)) && rcOutside.PtInRect(CPoint(rcInside.right,rcInside.bottom)))
		{
			pwndUse = pwndTemp;
		}
	}
	pWnd->ModifyStyle(WS_DISABLED,NULL);

	pWnd = pwndUse;

	LS_InvertWindowBorder(pWnd);

	pEdit->SetRedraw(FALSE);

	sTemp.Format(_T("ClassName:\n"));
	GetClassName(pWnd->GetSafeHwnd(),sClassName.GetBuffer(255),255);
	sClassName.ReleaseBuffer();
	g_peditClass->SetSel(0,-1);
	g_peditClass->ReplaceSel(sClassName);

    // If ALT is held down, do some memory poking and find generic strings
    if (GetAsyncKeyState(VK_MENU) & 0x8000)
    {
        int iBail = 0;
        LPCSTR pAddress = (LPCSTR) 0;
        MEMORY_BASIC_INFORMATION mbi;
        CString sTemp, sHeader;
        BOOL bRead, bWrite, bExec;

        pEdit->SetLimitText(0x7fffffff);

        do
        {
            VirtualQuery(pAddress, &mbi, sizeof(mbi));

            bRead = (mbi.AllocationProtect & (PAGE_READONLY | PAGE_READWRITE | PAGE_EXECUTE_READ | PAGE_EXECUTE_READWRITE));
            bWrite = (mbi.AllocationProtect & (PAGE_READWRITE | PAGE_WRITECOPY | PAGE_EXECUTE_READWRITE | PAGE_EXECUTE_WRITECOPY));
            bExec = (mbi.AllocationProtect & (PAGE_EXECUTE | PAGE_EXECUTE_READ | PAGE_EXECUTE_READWRITE | PAGE_EXECUTE_WRITECOPY));

            if (mbi.State != MEM_COMMIT)
            {
                bRead = bWrite = bExec = FALSE;
            }

            if (mbi.AllocationProtect & (PAGE_NOACCESS | PAGE_GUARD))
            {
                bRead = bWrite = bExec = FALSE;
            }

            if (bRead && bWrite)
            {
                // Poke through this memory for strings
                sTemp = MemoryStrings(pAddress, mbi.RegionSize);
                if (sTemp != "")
                {
                    sHeader.Format(_T("---------- Memory block 0x%.8x ----------"), (long) pAddress);
                    pEdit->ReplaceSel(sHeader + _T("\r\n"));
                    pEdit->ReplaceSel(sTemp);
                }
            }

            pAddress += mbi.RegionSize;

            iBail++;
            if (iBail > 10000)
                break;      // Don't go insane
        } while ((long) pAddress < 0x80000000);

        goto Cleanup;
    }

	// Get specific text out of the window

	if (sClassName.Find(_T("SysListView32")) != -1)
	{
		// Get a list-control representation of the information
		long nItems, nSubItems;
		CString sText;
		long i, j, lStyle;

		CListCtrl *pListCtrl = (CListCtrl *) pWnd;
		if (!pListCtrl)
			goto Cleanup;

		CHeaderCtrl* pHeaderCtrl = pListCtrl->GetHeaderCtrl();

		lStyle = GetWindowLong(pListCtrl->GetSafeHwnd(),GWL_STYLE);

		nItems = pListCtrl->GetItemCount();

		for (i = 0; i < nItems; i++)
		{
			sText = CSV(pListCtrl->GetItemText(i,0),bCSV,FALSE);
			if (lStyle & LVS_REPORT)
			{
				// We're in report format, so we need the rest of the columns
				nSubItems = 1;
				if (pHeaderCtrl != NULL)
				{
					nSubItems = pHeaderCtrl->GetItemCount();
				}

				if (nSubItems > 1)
					sText += (bCSV ? _T(",") : _T("\t"));
				for (j = 1; j < nSubItems; j++)
				{
					sTemp = pListCtrl->GetItemText(i,j);
					sText += CSV(sTemp,bCSV,j < nSubItems - 1);
				}
			}
            InsertText(pEdit, sText + _T("\r\n"), bNarrow);
		}
	} else if (sClassName.CompareNoCase(_T("SoftelTreeControl32")) == 0)
	{
		// This is a DreamWeaver tree/explorer control
		CTreeCtrl *pTree;
		HTREEITEM htiParent;
		pTree = (CTreeCtrl *) pWnd;
		CString sText;
		int iMax;

		if (!pTree)
			goto Cleanup;

		HTREEITEM hti = pTree->GetRootItem();
		sTemp = pTree->GetItemText(hti);
        InsertText(pEdit, sTemp, bNarrow);

		while (hti)
		{
			hti = (HTREEITEM) ((long) hti + 1);
			if ((long) hti > 2000)
				break;
			sText = CSV(pTree->GetItemText(hti),bCSV,FALSE);
			if (sText == "")
				break;
			if (sText.Left(4) == _T("@@@@"))
				continue;

			iMax = 0;
			while (sText.Find(_T("\t\t")) != -1)
			{
				sText.Replace(_T("\t\t"),_T("\t"));
				iMax++;
				if (iMax > 10)
					break;
			}

			if (bCSV)
			{
				int i;
				sTemp = _T("");
				i = sText.Find(_T('\t'));
				iMax = 0;
				while (i != -1)
				{
					sTemp += CSV(sText.Left(i),bCSV,TRUE);
					if (i < sText.GetLength() - 1)
						sText = sText.Mid(i+1);
					else
						sText = _T("");
					i = sText.Find(_T('\t'));
					iMax++;
					if (iMax > 15)
						break;
				}
				sText = sTemp += CSV(sText,bCSV,FALSE);
			}

			htiParent = pTree->GetParentItem(hti);
			sTemp = _T("");
			while (htiParent)
			{
				htiParent = pTree->GetParentItem(htiParent);
				sTemp += (bCSV ? _T(",") : _T("\t"));
			}
			InsertText(pEdit, sTemp + sText + _T("\r\n"), bNarrow);
		}
	} else if ((sClassName.CompareNoCase(_T("SysTreeView32")) == 0) || (sClassName.Find(_T("TreeControl")) != -1))
	{
		// Get a tree-style list of information
		CTreeCtrl *pTree;
		HTREEITEM htiParent;
		pTree = (CTreeCtrl *) pWnd;
		CString sText;

		if (!pTree)
			goto Cleanup;

		HTREEITEM hti = pTree->GetRootItem();
		sTemp = pTree->GetItemText(hti);
		InsertText(pEdit, sTemp + _T("\r\n"), bNarrow);

		while (hti = pTree->GetNextVisibleItem(hti))
		{
			sText = CSV(pTree->GetItemText(hti),bCSV,FALSE);
			htiParent = pTree->GetParentItem(hti);
			sTemp = "";
			while (htiParent)
			{
				htiParent = pTree->GetParentItem(htiParent);
				sTemp += (bCSV ? _T(",") : _T("\t"));
			}
			InsertText(pEdit, sTemp + sText + _T("\r\n"), bNarrow);
		}
	} else if ((sClassName.CompareNoCase(_T("List")) == 0) || (sClassName.CompareNoCase(_T("ListBox")) == 0))
	{
		long nLines;
		long i;
        char szNarrow[16384];
        int rc = ERROR_SUCCESS;

		CListBox *pListBox = (CListBox *) pWnd;

		if (!pListBox)
			goto Cleanup;

 		nLines = pListBox->GetCount();
		for (i = 0; i < nLines; i++)
		{
            if (bNarrow)
            {
                rc = SendMessageA(pListBox->m_hWnd, LB_GETTEXT, (WPARAM)i, (LPARAM)(LPCSTR)szNarrow);
                sTemp = szNarrow;
            }
            else
                pListBox->GetText(i, sTemp);
			InsertText(pEdit, sTemp + "\r\n", bNarrow);
		}
	} else if (sClassName.CompareNoCase(_T("Edit")) == 0)
	{
		int iStart, iEnd;
		CEdit *pEditCtrl = (CEdit *) pWnd;

		if (!pEditCtrl)
			goto Cleanup;

		pEditCtrl->GetSel(iStart,iEnd);
		pEditCtrl->SetRedraw(FALSE);
		pEditCtrl->SetSel(0,-1);
		pEditCtrl->OpenClipboard();
		EmptyClipboard();
		CloseClipboard();
		pEditCtrl->Copy();
		pEditCtrl->SetSel(iStart,iEnd);
		pEditCtrl->SetRedraw(TRUE);
		pEdit->Paste();
	} else if (sClassName.CompareNoCase(_T("SysHeader32")) == 0)
	{
		int iColumns, i;
		HDITEM hdItem;
		CString sHeader;
		CHeaderCtrl* pHeaderCtrl = (CHeaderCtrl *) pWnd;

		if (!pHeaderCtrl)
			goto Cleanup;

		iColumns = pHeaderCtrl->GetItemCount();
		hdItem.mask = HDI_TEXT;
		hdItem.pszText = sHeader.GetBuffer(1024);
		hdItem.cchTextMax = 1023;

		sTemp = "";

		for (i = 0; i < iColumns; i++)
		{
			pHeaderCtrl->GetItem(i,&hdItem);
			sTemp += CSV(hdItem.pszText,bCSV,i < iColumns - 1);
		}

		sHeader.ReleaseBuffer();
		InsertText(pEdit, sTemp + _T("\r\n"), bNarrow);
	} else if (sClassName.CompareNoCase(_T("msctls_statusbar32")) == 0)
	{
		CString sPart;
		int iInfo, iLength;
		CStatusBarCtrl *pSBCtrl = (CStatusBarCtrl *) pWnd;

		if (!pSBCtrl)
			goto Cleanup;

		int iParts = pSBCtrl->GetParts(0,NULL);

		sTemp = _T("");

		for (int i = 0; i < iParts; i++)
		{
			iLength = pSBCtrl->GetTextLength(i,&iInfo);
			sTemp += CSV(pSBCtrl->GetText(i),bCSV,i < iParts-1);
		}

		InsertText(pEdit, sTemp + _T("\r\n"), bNarrow);

	} else if (sClassName.CompareNoCase(_T("SysTabControl32")) == 0)
	{
		CTabCtrl *pTabCtrl = (CTabCtrl *) pWnd;
		int iTabs, i;
		TCITEM tcItem;
		TCHAR szTab[255];

		iTabs = pTabCtrl->GetItemCount();
		tcItem.cchTextMax = 255;
		tcItem.pszText = szTab;

		sTemp = _T("");
		szTab[0] = '\0';

		for (i = 0; i < iTabs; i++)
		{
			tcItem.mask = TCIF_TEXT;
			pTabCtrl->GetItem(i,&tcItem);
			sTemp += CSV(tcItem.pszText,bCSV,i < iTabs - 1);
		}

		InsertText(pEdit, sTemp + _T("\r\n"), bNarrow);
	} else if (sClassName.CompareNoCase(_T("QWidget")) == 0)
	{
        sTemp = "TempText";
		InsertText(pEdit, sTemp + _T("\r\n"), bNarrow);
	} else if (sClassName.Find(_T("ComboBox")) != -1)
	{
		CComboBox * pCombo = (CComboBox *) pWnd;
		int iItems, i;

		iItems = pCombo->GetCount();
		for (i = 0; i < iItems; i++)
		{
			pCombo->GetLBText(i,sTemp);
			InsertText(pEdit, sTemp + _T("\r\n"), bNarrow);
		}
	} else
	{
		pWnd->GetWindowText(sTemp);
		InsertText(pEdit, sTemp + _T("\r\n"), bNarrow);
	}

Cleanup:

	pEdit->SetSel(0,-1);
	pEdit->OpenClipboard();
	EmptyClipboard();
	CloseClipboard();
	pEdit->Copy();
	pEdit->SetSel(-1,-1);

	pEdit->SetRedraw(TRUE);
	pEdit->Invalidate();

	while (GetAsyncKeyState(VK_RBUTTON) & 0x8000)
		Sleep(10);

	LS_InvertWindowBorder(pWnd);
}

LRESULT CALLBACK MouseProc(
  int nCode,      // hook code
  WPARAM wParam,  // message identifier
  LPARAM lParam   // mouse coordinates
)
{
	MOUSEHOOKSTRUCT *pMouseHook;
	if (nCode < 0)
	{
		return CallNextHookEx(g_hHook,nCode,wParam,lParam);
	}
	
	pMouseHook = (MOUSEHOOKSTRUCT *) lParam;
	switch(wParam)
	{
		case WM_RBUTTONDOWN:
			if ((GetAsyncKeyState(VK_CONTROL) & 0x8000) && (GetAsyncKeyState(VK_SHIFT) & 0x8000))
				LS_GetWindowInfo(CWnd::FromHandle(WindowFromPoint(pMouseHook->pt)),pMouseHook->pt);
			else
				return CallNextHookEx(g_hHook,nCode,wParam,lParam);
			return -1;
		case WM_RBUTTONUP:
			if ((GetAsyncKeyState(VK_CONTROL) & 0x8000) && (GetAsyncKeyState(VK_SHIFT) & 0x8000))
				return -1;
			else
				return CallNextHookEx(g_hHook,nCode,wParam,lParam);
		default:
			return CallNextHookEx(g_hHook,nCode,wParam,lParam);
	}
	return CallNextHookEx(g_hHook,nCode,wParam,lParam);
}

void CALLBACK SetHook(HWND hEdit, HHOOK hHook, HWND hClear)
{
	g_peditMain = (CEdit *) CWnd::FromHandlePermanent(hEdit);
	if (!g_peditMain)
		g_peditMain = (CEdit *) CWnd::FromHandle(hEdit);
	g_hHook = hHook;
	g_pbtnClear = (CButton *) CWnd::FromHandle(hClear);
}
