// TextGrabberDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TextGrabber.h"
#include "TextGrabberDlg.h"
#include <windowsx.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CTextGrabberApp theApp;

CString g_sDebug;

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextGrabberDlg dialog

CTextGrabberDlg::CTextGrabberDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTextGrabberDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTextGrabberDlg)
	m_bClearOnNew = FALSE;
	m_bCSV = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTextGrabberDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTextGrabberDlg)
	DDX_Control(pDX, IDC_EDIT_CLASS, m_editClass);
	DDX_Control(pDX, IDC_CHECK_CSV, m_checkCSV);
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_BUTTON_SAVE, m_btnSave);
	DDX_Control(pDX, IDC_BUTTON_COPY, m_btnCopy);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btnClear);
	DDX_Control(pDX, IDC_CHECK_CLEAR, m_checkClear);
	DDX_Control(pDX, IDC_EDIT_TEXT, m_editText);
	DDX_Check(pDX, IDC_CHECK_CLEAR, m_bClearOnNew);
	DDX_Check(pDX, IDC_CHECK_CSV, m_bCSV);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTextGrabberDlg, CDialog)
	//{{AFX_MSG_MAP(CTextGrabberDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_COPY, OnButtonCopy)
	ON_BN_CLICKED(IDC_BUTTON_SAVE, OnButtonSave)
	ON_WM_SIZE()
	ON_WM_SIZING()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTextGrabberDlg message handlers

BOOL CTextGrabberDlg::OnInitDialog()
{
	ReadRegistry();

	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    m_editText.SetLimitText(32 * 1024 * 1024);
	GetWindowRect(&m_rcOrig);
	m_rcPrevious = m_rcOrig;

	CRect rcTemp;
	m_btnClear.GetWindowRect(rcTemp);
	m_iButtonHeight = rcTemp.bottom - rcTemp.top;
	m_iBottomDist = m_rcOrig.bottom - rcTemp.bottom;
	m_iButtonWidth = rcTemp.right - rcTemp.left;

	m_editText.GetWindowRect(rcTemp);
	m_iRightMargin = m_rcOrig.right - rcTemp.right;
	m_iEditDistFromBottom = m_rcOrig.bottom - rcTemp.bottom;

	m_fHookProc = NULL;
	InstallHook();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTextGrabberDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTextGrabberDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTextGrabberDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTextGrabberDlg::OnButtonClear() 
{
	m_editText.SetWindowText(_T(""));	
}

void CTextGrabberDlg::OnButtonCopy() 
{
	int iStart,iEnd;

	m_editText.GetSel(iStart,iEnd);
	m_editText.SetRedraw(FALSE);
	m_editText.SetSel(0,-1);
	m_editText.Copy();
	m_editText.SetSel(iStart,iEnd);
	m_editText.SetRedraw(TRUE);
}

void CTextGrabberDlg::OnButtonSave() 
{
    CString sPathName;
    CFileDialog StdDialog(FALSE,_T(".txt"));
    CStdioFile outFile;
    long result, nLines, i;
    CString sText;

    result = StdDialog.DoModal();
    if (result == IDOK)
    {
        sPathName = StdDialog.GetPathName();
        if (outFile.Open(sPathName,CFile::modeCreate | CFile::modeWrite | CFile::typeText))
        {
			long iLength;
			int iStart, iEnd;

			nLines = m_editText.GetLineCount();
			m_editText.GetSel(iStart,iEnd);
			for(i = 0; i < nLines; i++)
			{
				iLength = m_editText.LineIndex(i+1) - m_editText.LineIndex(i);
				if (iLength < 0)
				{
					m_editText.SetRedraw(FALSE);
					int i1,i2;
					m_editText.SetSel(0,-1);
					m_editText.GetSel(i1,i2);
					iLength = i2 - m_editText.LineIndex(i);
					m_editText.SetSel(iStart,iEnd);
					m_editText.SetRedraw(TRUE);
				}
				m_editText.GetLine(i,sText.GetBuffer(iLength+3),iLength);
 				sText.ReleaseBuffer(iLength);
				if (iLength > 2)
					sText = sText.Left(iLength-2);
				outFile.WriteString(sText + "\n");
			}
            outFile.Close();
        } else
        {
            sText = "Unable to open file \"";
            sText += sPathName;
            sText += "\" for writing.";
            MessageBox(sText,_T("Error opening file"),MB_ICONWARNING);
        }
    }

}

#ifdef _DEBUG
const TCHAR *g_szLibrary = _T("..\\..\\TextGrab\\debug\\TextGrab.dll");
#else
const TCHAR *g_szLibrary = _T("TextGrab.dll");
#endif

BOOL CTextGrabberDlg::InstallHook()
{
	FARPROC fInitProc;
	CString sText;
	CString sError;

	sError = "Hooks failed to install.";

	m_hDLL = LoadLibrary(g_szLibrary); 

	if (m_hDLL == NULL)
	{
		MessageBox(_T("The file \"TextGrab.dll\" could not be located.  Please ensure that this file is in the same directory as this executable"),_T("Error loading DLL"),MB_ICONWARNING);
		return FALSE;
	}

	fInitProc = GetProcAddress(m_hDLL,"SetHook");
	if (fInitProc == NULL)
	{
		MessageBox(_T("The hook function SetHook() could not be located in the TextGrab.dll.  This is an unusual error and may be the result of an old version of the software"),_T("Error loading DLL"),MB_ICONWARNING);
		return FALSE;
	}

	m_fHookProc = GetProcAddress(m_hDLL,"MouseProc");
	if (m_fHookProc == NULL)
	{
		MessageBox(_T("The hook function MouseProc() could not be located in the TextGrab.dll.  This is an unusual error and may be the result of an old version of the software"),_T("Error loading DLL"),MB_ICONWARNING);
		return FALSE;
	}

	// Unhook any existing hook of ours to prevent repetition of hooks
	if (m_hHook)
		UnhookWindowsHookEx(m_hHook);

	m_hHook = SetWindowsHookEx(WH_MOUSE,(long (__stdcall *)(int,unsigned int,long))m_fHookProc,m_hDLL,0);
	if (m_hHook == NULL)
	{
		sText.Format(_T("The mouse hook could not be set (error %ld).  This program will not function if it cannot set a mouse hook."),GetLastError());
		MessageBox(sText,_T("Error loading DLL"),MB_ICONWARNING);
		return FALSE;
	}

	m_fInitProc = (void (__stdcall *)(HWND, HHOOK, HWND)) (void *) fInitProc;
	m_fInitProc(m_editText.GetSafeHwnd(), m_hHook, m_checkClear.GetSafeHwnd());

	return TRUE;
}

void CTextGrabberDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);

	if (!IsWindow(GetSafeHwnd()))
		return;

	CRect rcTemp, rcWindow;

	if (!IsWindow(m_btnClear.GetSafeHwnd()))
		goto Cleanup;

	GetWindowRect(&rcWindow);

	m_editText.GetWindowRect(&rcTemp);
	rcTemp.right = rcWindow.right - m_iRightMargin;
	rcTemp.bottom = rcWindow.bottom - m_iEditDistFromBottom;
	ScreenToClient(&rcTemp);
	m_editText.MoveWindow(rcTemp);

	m_btnClear.GetWindowRect(&rcTemp);
	rcTemp.bottom = rcWindow.bottom - m_iBottomDist;
	rcTemp.top = rcTemp.bottom - m_iButtonHeight;
	ScreenToClient(&rcTemp);
	m_btnClear.MoveWindow(rcTemp);

	m_btnCopy.GetWindowRect(&rcTemp);
	rcTemp.bottom = rcWindow.bottom - m_iBottomDist;
	rcTemp.top = rcTemp.bottom - m_iButtonHeight;
	ScreenToClient(&rcTemp);
	m_btnCopy.MoveWindow(rcTemp);

	m_btnSave.GetWindowRect(&rcTemp);
	rcTemp.bottom = rcWindow.bottom - m_iBottomDist;
	rcTemp.top = rcTemp.bottom - m_iButtonHeight;
	ScreenToClient(&rcTemp);
	m_btnSave.MoveWindow(rcTemp);

	m_btnOK.GetWindowRect(&rcTemp);
	rcTemp.bottom = rcWindow.bottom - m_iBottomDist;
	rcTemp.top = rcTemp.bottom - m_iButtonHeight;
	rcTemp.right = rcWindow.right - m_iRightMargin;
	rcTemp.left = rcTemp.right - m_iButtonWidth;
	ScreenToClient(&rcTemp);
	m_btnOK.MoveWindow(rcTemp);

Cleanup:
	GetWindowRect(&m_rcPrevious);
}

void CTextGrabberDlg::OnSizing(UINT fwSide, LPRECT pRect) 
{
	if ((pRect->right - pRect->left) < (m_rcOrig.right - m_rcOrig.left))
	{
		// Too small horizontally

		if ((fwSide == WMSZ_LEFT) || (fwSide == WMSZ_TOPLEFT) || (fwSide == WMSZ_BOTTOMLEFT))
		{
			// restrict left side
			pRect->left = pRect->right - (m_rcOrig.right - m_rcOrig.left);
		} else
		{
			// restrict right side
			pRect->right = pRect->left + (m_rcOrig.right - m_rcOrig.left);
		}
	}

	if ((pRect->bottom - pRect->top) < (m_rcOrig.bottom - m_rcOrig.top))
	{
		// Too small vertically

		if ((fwSide == WMSZ_TOPLEFT) || (fwSide == WMSZ_TOPRIGHT) || (fwSide == WMSZ_TOP))
		{
			// restrict top side
			pRect->top = pRect->bottom - (m_rcOrig.bottom - m_rcOrig.top);
		} else
		{
			// restrict bottom side
			pRect->bottom = pRect->top + (m_rcOrig.bottom - m_rcOrig.top);
		}
	}

	CDialog::OnSizing(fwSide, pRect);
}

void CTextGrabberDlg::ReadRegistry()
{
	m_bClearOnNew = theApp.GetProfileInt(_T("Options"),_T("ClearAlways"),FALSE);
	m_bCSV = theApp.GetProfileInt(_T("Options"),_T("UseCSV"),FALSE);
}

void CTextGrabberDlg::WriteRegistry()
{
	UpdateData(TRUE);
	theApp.WriteRegistry(this);
}
